// ============================================================================
// Copyright (c) 2015 by Terasic Technologies Inc.
// ============================================================================
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// ============================================================================
//           
//  Terasic Technologies Inc
//  9F., No.176, Sec.2, Gongdao 5th Rd, East Dist, Hsinchu City, 30070. Taiwan
//  
//  
//                     web: http://www.terasic.com/  
//                     email: support@terasic.com
//
// ============================================================================
//Date:  Thu Jul  2 14:45:59 2015
// ============================================================================

//`define ENABLE_DDR3

module golden_top(

      ///////// ADC /////////
      input              ADC_CLK_10,

      ///////// AUDIO /////////
      inout              AUDIO_BCLK,
      output             AUDIO_DIN_MFP1,
      input              AUDIO_DOUT_MFP2,
      inout              AUDIO_GPIO_MFP5,
      output             AUDIO_MCLK,
      input              AUDIO_MISO_MFP4,
      inout              AUDIO_RESET_n,
      output             AUDIO_SCLK_MFP3,
      output             AUDIO_SCL_SS_n,
      inout              AUDIO_SDA_MOSI,
      output             AUDIO_SPI_SELECT,
      inout              AUDIO_WCLK,

      ///////// CAMERA /////////
      output             CAMERA_I2C_SCL,
      inout              CAMERA_I2C_SDA,
      output             CAMERA_PWDN_n,

      ///////// DAC /////////
      inout              DAC_DATA,
      output             DAC_SCLK,
      output             DAC_SYNC_n,

`ifdef ENABLE_DDR3
      ///////// DDR3 /////////
      output      [14:0] DDR3_A,
      output      [2:0]  DDR3_BA,
      output             DDR3_CAS_n,
      output             DDR3_CKE,
      inout              DDR3_CK_n,
      inout              DDR3_CK_p,
      output             DDR3_CS_n,
      output      [2:0]  DDR3_DM,
      inout       [23:0] DDR3_DQ,
      inout       [2:0]  DDR3_DQS_n,
      inout       [2:0]  DDR3_DQS_p,
      output             DDR3_ODT,
      output             DDR3_RAS_n,
      output             DDR3_RESET_n,
      output             DDR3_WE_n,
`endif /*ENABLE_DDR3*/

      ///////// FLASH /////////
      inout       [3:0]  FLASH_DATA,
      output             FLASH_DCLK,
      output             FLASH_NCSO,
      output             FLASH_RESET_n,

      ///////// FPGA /////////
      input              FPGA_RESET_n,

      ///////// GPIO /////////
      inout       [7:0]  GPIO,

      ///////// GSENSOR /////////
      output             GSENSOR_CS_n,
      input       [2:1]  GSENSOR_INT,
      inout              GSENSOR_SCLK,
      inout              GSENSOR_SDI,
      inout              GSENSOR_SDO,

      ///////// HDMI /////////
      input              HDMI_AP,
      inout              HDMI_I2C_SCL,
      inout              HDMI_I2C_SDA,
      inout              HDMI_LRCLK,
      inout              HDMI_MCLK,
      input              HDMI_RX_CLK,
      input       [23:0] HDMI_RX_D,
      input              HDMI_RX_DE,
      inout              HDMI_RX_HS,
      input              HDMI_RX_INT1,
      inout              HDMI_RX_RESET_n,
      input              HDMI_RX_VS,
      inout              HDMI_SCLK,

      ///////// HEX0 /////////
      output      [6:0]  HEX0,

      ///////// HEX1 /////////
      output      [6:0]  HEX1,

      ///////// KEY /////////
      input       [4:0]  KEY,

      ///////// LEDR /////////
      output      [9:0]  LEDR,

      ///////// LSENSOR /////////
      inout              LSENSOR_INT,
      output             LSENSOR_SCL,
      inout              LSENSOR_SDA,

      ///////// MAX10 /////////
      input              MAX10_CLK1_50,
      input              MAX10_CLK2_50,
      input              MAX10_CLK3_50,

      ///////// MIPI CS2 CAMERA /////////
      output             MIPI_CS_n,
      output             MIPI_I2C_SCL,
      inout              MIPI_I2C_SDA,
      input              MIPI_PIXEL_CLK,
      input       [23:0] MIPI_PIXEL_D,
      input              MIPI_PIXEL_HS,
      input              MIPI_PIXEL_VS,
      output             MIPI_REFCLK,
      output             MIPI_RESET_n,

      ///////// MTL2 /////////
      output      [7:0]  MTL2_B,
      inout              MTL2_BL_ON_n,
      output             MTL2_DCLK,
      output      [7:0]  MTL2_G,
      output             MTL2_HSD,
      output             MTL2_I2C_SCL,
      inout              MTL2_I2C_SDA,
      input              MTL2_INT,
      output      [7:0]  MTL2_R,
      output             MTL2_VSD,

      ///////// NET /////////
      output             NET_GTX_CLK,
      input              NET_INT_n,
      input              NET_LINK100,
      output             NET_MDC,
      inout              NET_MDIO,
      output             NET_RST_N,
      input              NET_RX_CLK,
      input              NET_RX_COL,
      input              NET_RX_CRS,
      input       [3:0]  NET_RX_D,
      input              NET_RX_DV,
      input              NET_RX_ER,
      input              NET_TX_CLK,
      output      [3:0]  NET_TX_D,
      output             NET_TX_EN,
      output             NET_TX_ER,

      ///////// PM /////////
      output             PM_I2C_SCL,
      inout              PM_I2C_SDA,

      ///////// PS2 /////////
      inout              PS2_CLK,
      inout              PS2_CLK2,
      inout              PS2_DAT,
      inout              PS2_DAT2,

      ///////// RH /////////
      input              RH_TEMP_DRDY_n,
      output             RH_TEMP_I2C_SCL,
      inout              RH_TEMP_I2C_SDA,

      ///////// SD /////////
      output             SD_CLK,
      inout              SD_CMD,
      inout       [3:0]  SD_DATA,

      ///////// SW /////////
      input       [9:0]  SW,

      ///////// UART /////////
      output             UART_RESET_n,
      input              UART_RX,
      output             UART_TX
);


//=======================================================
//  REG/WIRE declarations
//=======================================================
wire rts; // request to send		  
wire cts; // clear to send
wire rxd;
wire txd;
wire connect_state;
reg  [25:0]   heart_beat_cnt;

//=======================================================
//  Structural coding
//=======================================================


    NEEK10_QSYS u0 (
        .clk_clk                                    (MAX10_CLK1_50),     //                                 clk.clk
        .reset_reset_n                              (FPGA_RESET_n),      //                               reset.reset_n
        .uart_external_connection_rxd               (rxd),               //            uart_external_connection.rxd
        .uart_external_connection_txd               (txd),               //                                    .txd
        .uart_external_connection_cts_n             (cts),               //                                    .cts_n
        .uart_external_connection_rts_n             (rts),               //                                    .rts_n
        .tmd_status_external_connection_export      (LEDR[1]),           //      tmd_status_external_connection.export
        .rh_temp_drdy_n_external_connection_export  (RH_TEMP_DRDY_n),    //  rh_temp_drdy_n_external_connection.export
        .rh_temp_i2c_sda_external_connection_export (RH_TEMP_I2C_SDA),   // rh_temp_i2c_sda_external_connection.export
        .rh_temp_i2c_scl_external_connection_export (RH_TEMP_I2C_SCL),    // rh_temp_i2c_scl_external_connection.export
        .bts_status_external_connection_export      (connect_state)       //      bts_status_external_connection.export     
	 );

//Terasic TMD
assign GPIO[0] = txd;
assign rxd = GPIO[1];
assign GPIO[3] = rts;
assign cts     = GPIO[2];
assign connect_state = GPIO[4];

//Heart beat by 50MHz clock
always @(posedge MAX10_CLK3_50 or negedge FPGA_RESET_n)
  if (!FPGA_RESET_n)
      heart_beat_cnt <= 26'h0; //0x3FFFFFF
  else
      heart_beat_cnt <= heart_beat_cnt + 1'b1;

endmodule
