/*
 * "Hello World" example.
 *
 * This example prints 'Hello from Nios II' to the STDOUT stream. It runs on
 * the Nios II 'standard', 'full_featured', 'fast', and 'low_cost' example
 * designs. It runs with or without the MicroC/OS-II RTOS and requires a STDOUT
 * device in your system's hardware.
 * The memory footprint of this hosted application is ~69 kbytes by default
 * using the standard reference design.
 *
 * For a reduced footprint version of this template, and an explanation of how
 * to reduce the memory footprint for a given application, see the
 * "small_hello_world" template.
 *
 */

#include <stdio.h>
#include "terasic_includes.h"
#include "Temp_RH.h"


bool Isconnect()
{
	return IORD(BTS_STATUS_BASE,0);
}


int main()
{
  int uart;
 // char init_CMD_MODE[] = "test\r";
  double HumidityData[64];
  double TemperatureData[64];
  uart = open(UART_NAME, O_ACCMODE);
  if(RH_Temp_Sensor_init())
	  printf("Init sucesses\n");
  else
      printf("Init Fail\n");

  printf("Waiting....\n");
  while(!Isconnect());
  printf("connecting....\n");

  while(1)
  {
	 usleep(1000000);
	 sprintf(TemperatureData,"Temperature=%.1f, ",sensor_GetTemperatureData());
	 write(uart, TemperatureData, strlen(TemperatureData));
	 usleep(1000000);
	 sprintf(HumidityData,"Humidity=%.1f\r\n",sensor_GetHumidityData());
	 write(uart, HumidityData, strlen(HumidityData));
  }

  close(uart);
  return 0;
}
